<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
    
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Firma de Ficheros en 2 Fases</title>

<script type="text/javascript" language="javascript" src="common-js/time.js"></script>
<script type="text/javascript" language="javascript" src="common-js/appletHelper.js"></script>
<script type="text/javascript" language="javascript" src="common-js/instalador.js"></script>
<script type="text/javascript" language="javascript" src="common-js/firma.js"></script>
<script type="text/javascript" language="javascript" src="common-js/instalador.js"></script>
<script type="text/javascript" language="javascript" src="common-js/htmlEscape.js"></script>
<script type="text/javascript" language="javascript" src="common-js/utils.js"></script>
<script type="text/javascript" language="javascript" src="common-js/styles.js"></script>
<script type="text/javascript" language="javascript" src="common-js/firmaWeb.js"></script>
<script type="text/javascript" language="javascript" src="common-js/encode.js"></script>
<script type="text/javascript" language="javascript" src="constantes.js"></script>
	
<script type="text/javascript" language="javascript">
	function enviar() {
		
		//Inicializar el Cliente de Firma
		clienteFirma.initialize();
		
		// El fichero a firmar
		var fichero= document.getElementById("fichero");
		
		
		// Configuramos el proceso de firma
		
		// Formato y Modo de Firma
		var formato= getFormato();
		var modo = getModo();
		
		// Formato --> CMS, XADES, XMLDSIGN, NONE
		clienteFirma.setSignatureFormat(formato);
		
		// Modo --> EXPLICIT, IMPLICIT
		clienteFirma.setSignatureMode(modo);
				
		// Defino el fichero que voy a firmar. 
		// Otros posibles tipos de datos a firmar: 
		// cadena de datos en base64 --> setData; 
		// hash codificado en base64 --> setHash 
				
				
		clienteFirma.setFileuri(fichero.value);
		clienteFirma.setShowErrors(false);
		firmar();
		
		if(!clienteFirma.isError())
		{
			//Estructura de firma en base 64
			document.getElementById("firmaB64").value=clienteFirma.getSignatureBase64Encoded();
				
		}
		
		else
		{
			alert("No se ha podido firmar: "+clienteFirma.getErrorMessage());
			return false;
		}
		
		//En base64 el certificado del firmante
		var certificado = document.getElementById("certificado");
		certificado.value = clienteFirma.getSignCertificateBase64Encoded();
		
		//El contenido del fichero a firmar codificado en base 64 - No necesario si no tengo custodia
		//var contenido = document.getElementById("contenidoFichero");
		//contenido.value = clienteFirma.getFileBase64Encoded(false);
		
		// El Hash del fichero a firmar codificado en base 64
		var hash = document.getElementById("hash");
		hash.value = clienteFirma.getFileHashBase64Encoded(true);
		
						
	}

	function getFormato()
		{
				var selectFormato= document.getElementById('formato');
				var valueFormato= selectFormato.options[selectFormato.selectedIndex].value;
				return valueFormato;
		}
		
	function getModo() 
		{
				var selectModo = document.getElementById('modo');
				var valueModo = selectModo.options[selectModo.selectedIndex].value;
				return valueModo;	
		}	
	
</script>

</head>
<body onload="cargarAppletFirma()">

<!-- CÓDIGO DE EJEMPLO - NO RECOMENDADO PARA USO DIRECTO EN ENTORNOS DE PRODUCCIÓN -->
	
	<div>		
		Firma De Ficheros en 2 Fases
	</div>
	
	

	<form id="formulario" action="firmaFicheros2FasesWS.jsp" method="post">
		
		<input type="text" id="firmaB64" name="firmaB64" style="visibility: hidden; display: none;" >
		<input type="text" id="certificado" name="certificado" style="visibility: hidden; display: none;">
		<!-- <input type="text" id="contenidoFichero" name="contenidoFichero" style="visibility: hidden; display: none;"> No es necesario enviar si no tengo custodia -->
		<input type="text" id="hash" name="hash" style="visibility: hidden; display: none;">
		
		<div class="contenido">
			Formato de firma electrónica:
    	
    		<select name="formato" id="formato">
	    		<option value="CMS" selected="selected">CMS</option>
				<option value="CADES-BES">CAdES</option>
				<option value="XADES-BES">XAdES</option>
				<option value="XMLDSIGN">XML D-Sign</option>
	    		<option value="NONE">Ninguno (firma digital)</option>
	    	</select>
		</div>
		
		<div class="contenido">Modo de firma electrónica: 
			<select	name="modo" id="modo">
				<option value="EXPLICIT" selected="selected">Explícita</option>
				<option value="IMPLICIT">Implícita</option>
			</select>
		</div>
					
		<div class="contenido">Fichero a firmar : <input type="file" id="fichero" name="fichero"></div>
		<br><br>
		<input type="submit" value="Firmar Fichero" onclick="return enviar();">
		
	</form>		
</body>
</html>