<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ page import="java.util.Enumeration"%>
<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.Set"%>
<%@ page import="java.util.Iterator"%>

<%@ page import="org.w3c.dom.Document"%>
<%@ page import="org.apache.axis.utils.XMLUtils" %>

<%@ page import="com.telventi.afirma.wsclient.utils.UtilsWebService"%>
<%@ page import="com.telventi.afirma.wsclient.utils.UtilsFileSystem"%>

<%@ page import="es.juntadeandalucia.soporteae.configuracion.Preferencias"%>
<%@ page import="es.juntadeandalucia.soporteae.utils.UtilsWebServiceAE"%>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Firma de Ficheros en 2 Fases</title>
</head>

<body>
<%
	//CÓDIGO DE EJEMPLO - NO RECOMENDADO PARA USO DIRECTO EN ENTORNOS DE PRODUCCIÓN

	//Cargar desde el Archivo de Propiedades los distintos valores	
	
	Preferencias configuracion = new Preferencias();
	configuracion.cargarConfiguracion();

	String appId = configuracion.obtenerParametro("general.idAplicacion");

	//Varios parámetros necesarios
	String certificado = "";
	String firmaB64 = "";
	String contenidoFichero = "";
	String fichero = "";
	String hash = "";
	String formato = "";
	
	
	//Servicios a utilizar
	String nombreServicioFirma = configuracion.obtenerParametro("firma.2fases");
	String nombreServicioValidar = configuracion.obtenerParametro("validar.nombreServicio");
	String formatoValidacionFirmaPlataforma = configuracion.obtenerParametro("firma.formatoValidacionFirmaPlataforma");
	
	//URL de ACCESO a los Servicios
	String endpoint = configuracion.obtenerParametro("general.endpoint");

	//KEYSTORE que contiene los Certificado de @firma
	System.setProperty("javax.net.ssl.trustStore", configuracion.obtenerParametro("general.sslKeystore"));
	
	//Acerca de la password del Trustore 
	// No es necesario definirla si es 'changeit'
	//en caso de ser necesario habría que indicar
	// System.setProperty("javax.net.ssl.trustStorePassword", configuracion.obtenerParametro("general.sslKeystorePassword"));
	
	// FIN DE CONFIGURACIÓN DESDE ARCHIVO DE PROPIEDADES
	
	///////////////////////////////////////////////////////////////////////////////////
	//							 FIRMA DE FICHEROS									 //
	///////////////////////////////////////////////////////////////////////////////////
	
	System.out.println("[INICIO PROCESO DE FIRMA EN 2 FASES]");
	
	// 	FASE 1	

	// Se recuperan los datos necesario para la firma del Fichero obtenido desde el formulario
	// Estrutura de Firma en base64 --> firmaB64 
	// Certificado seleccionado en base 64 --> certificado
	// El contenido del fichero a firmar codificado en base 64 --> contenidoFichero
	// El fichero a firmar --> fichero
	// Formato de la Firma --> formato
	
	Enumeration paramNames = request.getParameterNames();

	while (paramNames.hasMoreElements()) {
		String paramName = (String) paramNames.nextElement();

		if (paramName.equals("firmaB64")) {
			firmaB64 = request.getParameterValues(paramName)[0];
		}
		if (paramName.equals("certificado")) {
			certificado = request.getParameterValues(paramName)[0];
		}
		//if (paramName.equals("contenidoFichero")) {
		//	contenidoFichero = request.getParameterValues(paramName)[0];
		//}		
		if (paramName.equals("fichero")) {
			fichero = request.getParameterValues(paramName)[0];
		}
		if (paramName.equals("hash")) {
			hash = request.getParameterValues(paramName)[0];
			System.out.println("Valor de Hash "+hash);
		}
		if (paramName.equals("formato")) {
			
			// ### BUG de la Plataforma ###
			// Para el formato XMLDSIG es necesario modificar el identificador pasado como parámetro,
			// pues dicho identificador no coincide para el cliente de firma y la invocación del servicio
			
			formato = request.getParameterValues(paramName)[0];
			
			if (formato.equals("XMLDSIGN"))
				formato = "XMLDSIG";
		}		
	}	
	
	// Obtenemos el Nombre del Fichero que vamos a firmar
	//String fileName = UtilsFileSystem.getNameFromFilePath(fichero);
	
	// Obtenemos la extensión del Fichero que vamos a firmar
	//String fileType = UtilsFileSystem.getExtensionFromFilePath(fichero);
	
	//Punto de ruptura 
	
	// FASE 2

	//  Preparación de la petición al servicio Web de FirmaUsuario2FasesF2
	//  Parámetros de la llamada la web Service: 
	//		identificador de aplicación, el getSignature en Base64, 
	//		getSignCertificate en base64, el formato de firma, documento, nombre documento, 
	//		tipo de documento, algoritmo de cifrado y booleano sobre el almacenamiento en custodia

	//CASUISTICA DE LA LLAMADA
	
	// 1º posibilidad - Enviando el archivo a @firma, indicando contenido ,nombre y tipo. True o False según se custodia o no el documento (en función del alta)
	//Document twoPhasesUserSignatureF2Request = UtilsWebService.prepareTwoPhasesUserSignatureF2Request(appId, firmaB64, certificado, formato, contenidoFichero, fileType, fileName,"SHA1","false");
	// 2º posibilidad - No enviando el archivo a @firma 
	Document twoPhasesUserSignatureF2Request = UtilsWebService.prepareTwoPhasesUserSignatureF2Request(appId, firmaB64, certificado, formato, "", "", "","SHA1","false");
	// Formateando los mensajes de la Consola
	
	//Punto de ruptura 
	
	// Mostramos el mensaje XML a enviar en Consola
	System.out.println("Mensaje petición SOAP enviada a @firma " +XMLUtils.DocumentToString(twoPhasesUserSignatureF2Request));
	
	//Lanzamiento de la petición WS

	String respuesta = UtilsWebService.launchRequest(endpoint,nombreServicioFirma, twoPhasesUserSignatureF2Request);

	System.out.println("Mensaje respuesta SOAP de @firma ");
	System.out.println(respuesta);
	
	//Punto de ruptura 

	if (!UtilsWebService.isCorrect(respuesta)) {
		System.err.println();
		System.err.println("La petición de Firma Usuario 2 Fases F2 no ha sido satisfactoria. Saliendo ...");
	}

	//Obtención del identificador de transaccion 

	String transactionId = UtilsWebService.getInfoFromDocumentNode(respuesta, "idTransaccion");
	System.out.println("Extrayendo el identificador de transaccion de la respuesta..."+transactionId);
	System.out.println("[/PROCESO DE FIRMA 2 FASES FINALIZADO]");
	
	//////////////////
	// Fin de la Firma en 2 Fases; Un siguiente paso --> Procedo a Validar la Firma realizada
	
	///////////////////////////////////////////////////////////////////////////////////
	//							 VALIDACIÓN DE FIRMA									 //
	///////////////////////////////////////////////////////////////////////////////////

	// Preparación de la petición al servicio Web de ValidarFirma
	System.out.println("[Validando FIRMA ELECTRÓNICA de la Plataforma...]");

	//Recuperar del mensaje de Entrada la firma el justificantede Firma
	String evidence = UtilsWebService.getInfoFromDocumentNode(respuesta, "justificanteFirmaElectronica");

	Document eSignatureValidationRequest = null;
	

	try {
		// appId Identificador de la aplicación 
		// evidence Firma Electrónica a validar (codificada en Base64) --> Justificante de firma anteriormente realizada
	    // formatoValidacionFirmaPlataforma Formato de Firma usado para validar (parametro de la plataforma) 
	    // hash Hash de los datos firmados codificado en Base64 -- > Blanco pues el justificante no tiene un hash asociado
		// hashAlgorithm Algoritmo de hash empleado en el cálculo del hash anterior --> Blanco
	 	// data Datos originales firmados codificados en Base64 --> Blanco
		eSignatureValidationRequest = UtilsWebService.prepareValidateSignatureRequest(appId, new String(evidence), formatoValidacionFirmaPlataforma, "".getBytes(), "", "".getBytes());
	} catch (Exception e) {
		System.err.println("..[/Petición incorrectamente preparada]");

	}

	// Lanzamiento de la petición WS

	String respuestaValidar = UtilsWebService.launchRequest(endpoint,nombreServicioValidar, eSignatureValidationRequest);

	if (!UtilsWebService.isCorrect(respuestaValidar)) {
		System.err.println();
		System.err.println("La petición de verificación de la Firma Electrónica de la Plataforma no ha sido satisfactoria. Saliendo ...");
	}
	
	//2º Validación
	
	System.out.println("[2º Validando FIRMA ELECTRÓNICA de la Plataforma...]");
	
	String evidence2 = firmaB64;
	
	Document eSignatureValidationRequest2 = null;
	

	try {
		// appId Identificador de la aplicación 
		// evidence Firma Electrónica a validar (codificada en Base64) --> Justificante de firma anteriormente realizada
	    // formatoValidacionFirmaCliente Formato de Firma usado para validar (parametro de la plataforma) 
	    // hash Hash de los datos firmados codificado en Base64 -- > Obtenido por el Cliente de Firma.
		// hashAlgorithm Algoritmo de hash empleado en el cálculo del hash anterior --> Normalmente SHA1
	 	// data Datos originales firmados codificados en Base64 --> Blanco
		eSignatureValidationRequest2 = UtilsWebService.prepareValidateSignatureRequest(appId, new String(evidence2), formato, hash.getBytes(), "SHA1", "".getBytes());
	} catch (Exception e) {
		System.err.println("..[/Petición incorrectamente preparada]");

	}

	// Lanzamiento de la petición WS

	String respuestaValidar2 = UtilsWebService.launchRequest(endpoint,nombreServicioValidar, eSignatureValidationRequest2);

	if (!UtilsWebService.isCorrect(respuestaValidar)) {
		System.err.println();
		System.err.println("La petición de verificación de la Firma Electrónica de la Plataforma no ha sido satisfactoria. Saliendo ...");
	}
	
	

	//Procedemos a mostrar la información de la firma realizada: 
	//	Datos de la persona que ha firmado
	//	Información del Fichero Firmado : idTransaccion
	
	// 1 Llamada al ObtenerInfo
	
	System.out.println("[PROCESO DE OBTENER INFORMACIÓN DE FIRMANTES]");
	// Construcción del mensaje de entrada al servicio de obtenerInfo de certificado
	Document certificateObtenerInfoRequest = UtilsWebService.prepareGetCertificateInfoRequest(appId, certificado);
	String compruebaObtenerInfo = UtilsWebService.launchRequest(endpoint, "ObtenerInfoCertificado", certificateObtenerInfoRequest);
	
	// Procesado de la respuesta
	HashMap campos = UtilsWebServiceAE.obtenerInfoCertificado(compruebaObtenerInfo);
	
	// Busco los campos que quiero mostrar. Nombre, Apellidos y NIF
	//Busco en el XML los campos que me interese mostrar: NIFResponsable y NombreApellidosResponsable
	
	Set claves = campos.keySet();
	Iterator listaClaves = claves.iterator();
	
	String NIFResponsable= "";
	String NombreApellidosResponsable="";
	
	//1º Elemento
		
	while(listaClaves.hasNext()) {
		
		//Obtengo el elemento
		String s = listaClaves.next().toString();

		if (s.equals("NIFResponsable")){
			
			NIFResponsable=(String)campos.get(s);
			System.out.println("[/Encontrado NIF] "+NIFResponsable);
		}
		if (s.equals("NombreApellidosResponsable")){
			
			NombreApellidosResponsable=(String)campos.get(s);
			System.out.println("[/Encontrado Nombre] "+NombreApellidosResponsable);
		}
		
	}
	
	System.out.println("[/PROCESO DE OBTENER INFORMACIÓN DE FIRMANTES FINALIZADO]");
	
	//Escribimos algunos datos del firmante y del fichero firmado
	
	// ##########################################
	// ¿este proceso de firma es correcto al 100%? - No olvidar control de Sesiones propio del aplicativo, en función de la 
	// autenticación realizada previamente			
	%>
	<br>
		<strong>FIRMANTE <%=NombreApellidosResponsable%></strong>
	<br>   
		<strong>NIF del FIRMANTE <%=NIFResponsable%></strong>
	<br>   
		<strong>Identificador de Transacción <%=transactionId%></strong>
		
</html>